(require 'compile)

(setq af--hg-test-traceback
      (rx
       bol
       "+  File \""
       (one-or-more not-newline)
       "/install/lib/python/"
       (group (one-or-more (not (any "\""))))
       ", line "
       (group (one-or-more digit))
       )
      )

(setq compilation-error-regexp-alist-alist
  (cons '(mercurial-test-output-tb af--hg-test-traceback 1 2)
        (assq-delete-all 'mercurial-test-output-tb
                         compilation-error-regexp-alist-alist)))

(setq af--hg-check-code-error-re
      (rx
       bol
       "+  "
       (group (one-or-more not-newline))
       ":"
       (group (one-or-more digit))
       ":"
       )
      )

(setq compilation-error-regexp-alist-alist
  (cons '(mercurial-check-code-output af--hg-check-code-error-re 1 2)
        (assq-delete-all 'mercurial-check-code-output
                          compilation-error-regexp-alist-alist)))

(add-to-list 'compilation-error-regexp-alist 'mercurial-test-output-tb)
(add-to-list 'compilation-error-regexp-alist 'mercurial-check-code-output)

;; to debug:
;;(setq compilation-error-regexp-alist '(mercurial-check-code-output))
